import valve.source
import valve.source.a2s
import valve.source.master_server


def get_server_list():
    with valve.source.master_server.MasterServerQuerier() as msq:
        return [address for address in msq.find(gamedir=u"NeotokyoSource")]


def get_populated_servers(server_list, min_pop):
    populated_servers = []

    for address in server_list:
        try:
            with valve.source.a2s.ServerQuerier(address) as server:
                info = server.info()
                players = server.players()

                # AFAIK bot is not included in "player_count" so no need to readjust it man
                if players["player_count"] >= min_pop:
                    # Reduce amount of object juggling in nt_bot.py by appending all info to one object
                    info["player_count"] = players["player_count"]
                    populated_servers.append(info)

        except valve.source.a2s.NoResponseError:
            continue

    return populated_servers
